entusiasticsQuizGame = {};
entusiasticsQuizGame.questions_answered = 0;

entusiasticsQuizGame.goon = function(quizID, url) {
	
	// make sure there is answer selected
	var qType = jQuery('#entusiastics-question-form-' + quizID + ' input[name=question_type]').val();	
	var chkClass = 'entusiastics-quiz-' + qType;
	jQuery('#entusiastics-quiz-action-' + quizID).attr('disabled', true);
	
	// is any checked?
	var anyChecked = false;
	jQuery('#entusiastics-question-form-' + quizID + ' .' + chkClass).each(function(){
		if(this.checked) {
			let profile_id = jQuery(this).attr('data-profile');
			jQuery('#profile-id-selected').val(profile_id);
			anyChecked = true;
		} 	
	});
	
	if(!anyChecked && (qType != 'text')) {
		alert(jQuery('#confirm_question_message').val());
		jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');
		jQuery('#profile-id-selected').val();
		return false;
	}

	if(qType == 'text' && jQuery('#entusiastics-quiz-form-' + quizID + ' textarea[name=answer]').val() == '') {
		alert(jQuery('#confirm_question_message').val());
		jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');
		jQuery('#profile-id-selected').val();
		return false;
	}

	dataLayer.push({
		'event': 'pagina',
		'nombre quiz': 'Comunicación interna',
		'nombre_seccion': '¿Cómo que de qué hablo?…',
		'número_seccion': '2',
		'seccion_anterior': 'Título anterior',
		'valor_selecionado': 'Prueba',
		'indicador': 'Optimista'
	});

	jQuery('#entusiastics-quiz-wrap-'+quizID).fadeOut();
	jQuery('#entusiastic-summary').fadeOut();

	// submit the answer by ajax
	data = jQuery('#entusiastics-question-form-'+quizID).serialize();
	data += '&action=entusiastics_quiz_game_ajax';
	data += '&entusiastic_game_quiz_action=answer';
	this.questions_answered++;
	data += '&total_questions=' + this.questions_answered;

	setTimeout(function(){
		jQuery('#entusiasticsLoading').fadeIn();
	}, 500);

	setTimeout(function(){
		postData(quizID, url, data);
	}, 1000);
}

entusiasticsQuizGame.initializeQuestion = function(quizID) {

	// Document Ready
	jQuery(document).ready(function() {

		var acc = document.getElementsByClassName("accordion");
		var i;

		for (i = 0; i < acc.length; i++) {

			acc[i].addEventListener("click", function() {

				this.classList.toggle("active");

				var panel = this.nextElementSibling;

				if (panel.style.maxHeight) {
					panel.style.maxHeight = null;
				} else {
					panel.style.maxHeight = panel.scrollHeight + "px";
				}

			});

		}
	});

	jQuery('.accordion-button').on('click', function(){

		jQuery('.summary-open-button').toggleClass('active');

		var panel = jQuery(this).parent().parent().parent().find('.accordion-panel');

		if (panel.css('max-height') != '0px') {
			jQuery('.accordion-button').removeClass("open");
			panel.css('max-height', '0px');
		} else {
			jQuery('.accordion-button').addClass("open");
			panel.css("max-height", panel.prop('scrollHeight') + 'px');
		}

		return false;
	});

	jQuery('#entusiastics-close-quiz-button').on('click', function(){
		jQuery('#entusiastics-info-modal').fadeIn();
	});

	jQuery('#entusiastics-modal-close-button').on('click', function(){

		// dataLayer.push({
		// 	'quiz_id': ''.
		// 	'titulo_quiz': '',
		// 	'usuario_id': '',
		// 	'usuario': '',
		// 	'event': 'leaveQuiz'
		// });

		jQuery('#entusiastics-info-modal').fadeOut();
		
		window.location.href = translated_strings.shortcode_url;
	});

	jQuery('#entusiastics-modal-continue-button').on('click', function(){
		jQuery('#entusiastics-info-modal').fadeOut();
	});

	jQuery(".entusiastics-quiz-frontend").click(function() {

		if(this.type == 'radio') {

			jQuery(".entusiastics-quiz-label").removeClass('active');
			jQuery(this).parent().toggleClass('active');
		}

		if(jQuery('#entusiastics-quiz-action-' + quizID).css('visibility') == 'visible') {
			jQuery([document.documentElement, document.body]).animate({
				scrollTop: jQuery('#entusiastics-quiz-action-' + quizID).offset().top
			}, 500);
		}

		if(this.type == 'radio' || this.type == 'checkbox') {		
			// enable button			
			jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');
		}

	});

	jQuery(".entusiastics-quiz-frontend").on('change', function() {		
		
		if(this.type == 'checkbox') {

			if(this.checked) {

				jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');
				jQuery('#entusiastics-quiz-info-checkbox-text').fadeOut();

			} else {

				var anyChecked = false;
				jQuery('#entusiastics-question-form-' + quizID + ' .entusiastics-quiz-' + this.type).each(function(){
					if(this.checked) {
						let profile_id = jQuery(this).attr('data-profile');
						jQuery('#profile-id-selected').val(profile_id);
						anyChecked = true;
					} 	
				});

				if(!anyChecked) {
					jQuery('#entusiastics-quiz-action-' + quizID).attr('disabled', 'disabled');
					jQuery('#entusiastics-quiz-info-checkbox-text').fadeIn();
				}
			}			
			
		}
	});
	
	jQuery(".entusiastics-quiz-frontend").on('keyup', function() {

		if(this.type == 'textarea') {

			if(jQuery(this).val() == '') {

				jQuery('#entusiastics-quiz-action-' + quizID).attr('disabled', 'disabled');

			} else {

				jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');
			}
		}

	});
}

entusiasticsQuizGame.finalizeQuiz = function(quizID, sessionID, url) {

	let data = '&action=entusiastics_finalize_quizz';
	data += '&entusiastics_finalize_quizz=finalize';
	data += '&quiz_id='+quizID;
	data += '&session_id='+sessionID;

	jQuery('#entusiastics-quizzes-grid-container').fadeOut().remove();
	jQuery('#entusiastics-main-quiz-div-'+quizID).find('.entusiastics-quizz-wrapper').fadeOut();
	jQuery('#entusiasticsLoading').fadeIn();

	setTimeout(function(){
		postData(quizID, url, data);
	}, 1000);
}

entusiasticsQuizGame.startQuiz = function(quizID, url) {

	let data = jQuery('#entusiastics-quiz-form-'+quizID).serialize();
	data += '&action=entusiastics_quiz_game_ajax';
	data += '&entusiastic_game_quiz_action=start';

	jQuery('#entusiastics-quizzes-grid-container').fadeOut().remove();
	jQuery('#entusiastics-main-quiz-div-'+quizID).find('.entusiastics-quizz-wrapper').fadeOut();
	jQuery('#entusiasticsLoading').fadeIn();

	setTimeout(function(){
		postData(quizID, url, data);
	}, 1000);
}

function postData(quizID, url, data) {

	// console.log(data);
	jQuery.post(url, data, function(msg) {

		parts = msg.split("|ENTUSIASTICSQUIZGAME|");	  

		jQuery('#entusiastics-quiz-action-' + quizID).removeAttr('disabled');

		// redirect?
		if(parts[1].indexOf('[ENTUSIASTICS_QUIZ_GAME_REDIRECT]') != -1) {

			jQuery('#entusiasticsLoading').hide();

			var sparts = parts[1].split('[ENTUSIASTICS_QUIZ_GAME_REDIRECT]');
			window.location=sparts[1];
		}
		else {
			jQuery('#entusiasticsLoading').hide();
		  	// load next question or the final screen
		  	jQuery('#entusiastics-main-quiz-div-'+quizID).html(parts[1]);	

			// hide/show "go ahead" button depending on comment in the HTML code
			if(parts[1].indexOf('<!--hide_go_ahead-->') != -1) jQuery('#entusiastics-quiz-action-' + quizID).hide();
			else jQuery('#entusiastics-quiz-action-' + quizID).show();		  	  

			entusiasticsQuizGame.initializeQuestion(quizID);

		}

		jQuery('#entusiasticsLoading').hide();
	});
}

jQuery(function($){

	// Document Ready
	jQuery(document).ready(function() {

		if(jQuery('#entusiastics-title-block').length) {
			var padding_top = jQuery('#entusiastics-title-block').height();
			jQuery('.entusiastics-quiz__body-block').css('padding-top', padding_top);
		}		

		jQuery('#entusiastics-close-quiz-button').on('click', function(){
			jQuery('#entusiastics-info-modal').fadeIn();
		});

		var acc = document.getElementsByClassName("accordion");
		var i;

		for (i = 0; i < acc.length; i++) {

			acc[i].addEventListener("click", function(e) {

				e.preventDefault();

				this.classList.toggle("active");

				var panel = this.nextElementSibling;

				if (panel.style.maxHeight) {
					panel.style.maxHeight = null;
				} else {
					panel.style.maxHeight = panel.scrollHeight + "px";
				}

			});

		}
	});
});