<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://entusiastics.com
 * @since      1.0.0
 *
 * @package    Entusiastics_Quiz_Game
 * @subpackage Entusiastics_Quiz_Game/admin/partials
 */


?>

<div class="wrap">

	<h1 class="wp-heading-inline">
		<?php printf(__('Añadir/Editar Pregunta del "%s"', 'entusiastics-quiz-game'), $quiz->title)?>
	</h1>

	<ul class="header-links-list">

		<li>

			<a href="admin.php?page=entusiastics-quiz-game-quizzes">
				<?php _e('Volver a los quizzes', 'entusiastics-quiz-game')?>
			</a>

		</li>
		<span>|</span>
		<li>	
			<a href="admin.php?page=entusiastics-quiz-game-questions&quiz_id=<?php echo $quiz->id?>">
				<?php _e('Volver a las preguntas', 'entusiastics-quiz-game')?>
			</a>
		</li>
		<span>|</span>
		<a href="admin.php?page=entusiastics-quiz-game-quizzes&action=edit&id=<?php echo $quiz->id?>">
			<?php _e('Editar este Quiz', 'entusiastics-quiz-game')?>
		</a>
	</ul>

	<hr class="wp-header-end">

	<div class="postbox-container" style="width: 100%;">
		<div id="tree"></div>
	</div>

</div>